import { __assign } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import * as React from "react";
import { Dialog } from "./Dialog";
import { Button } from "./Button";
import { useTheme } from "./Theme/Providers";
import { Text } from "./Text";
import { useUid } from "./Hooks/use-uid";
export var AlertDialog = function (_a) {
    var isOpen = _a.isOpen, title = _a.title, subtitle = _a.subtitle, _b = _a.confirmLabel, confirmLabel = _b === void 0 ? "Confirm" : _b, onConfirm = _a.onConfirm, _c = _a.intent, intent = _c === void 0 ? "danger" : _c, onCancel = _a.onCancel, onClose = _a.onClose;
    var theme = useTheme();
    var id = useUid();
    var cancel = React.useCallback(function () {
        if (onCancel)
            onCancel();
        onClose();
    }, [onCancel, onClose]);
    var confirm = React.useCallback(function () {
        onConfirm();
        onClose();
    }, [onConfirm]);
    return (_jsx(Dialog, __assign({ role: "alertdialog", "aria-labelledby": id, onRequestClose: cancel, isOpen: isOpen }, { children: _jsxs("div", __assign({ css: { padding: "1.5rem" } }, { children: [_jsx(Text, __assign({ id: id, variant: "h5" }, { children: title }), void 0),
                subtitle && _jsx(Text, { children: subtitle }, void 0),
                _jsxs("div", __assign({ css: {
                        marginTop: theme.spaces.md,
                        display: "flex",
                        justifyContent: "flex-end"
                    } }, { children: [_jsx(Button, __assign({ autoFocus: true, onPress: cancel, variant: "ghost" }, { children: "Cancel" }), void 0),
                        _jsx(Button, __assign({ onPress: confirm, css: { marginLeft: theme.spaces.sm }, intent: intent }, { children: confirmLabel }), void 0)] }), void 0)] }), void 0) }), void 0));
};
//# sourceMappingURL=AlertDialog.js.map