import { __assign, __makeTemplateObject, __rest } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
/** @jsxImportSource @emotion/react */
import { css } from "@emotion/react";
import * as React from "react";
import { Text } from "./Text";
import PropTypes from "prop-types";
import { useTheme } from "./Theme/Providers";
import { IconChevronRight } from "./Icons";
var hideScrollbar = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  ::-webkit-scrollbar {\n    height: 0;\n    width: 0;\n  }\n"], ["\n  ::-webkit-scrollbar {\n    height: 0;\n    width: 0;\n  }\n"])));
/**
 * Breadcrumbs are useful to orient the user on your site,
 * especially when working with hierarchies of content.
 */
export var Breadcrumbs = function (_a) {
    var children = _a.children, _b = _a.size, size = _b === void 0 ? "md" : _b, overflowX = _a.overflowX, other = __rest(_a, ["children", "size", "overflowX"]);
    var theme = useTheme();
    return (_jsx("nav", __assign({ className: "Breadcrumbs", "aria-label": "breadcrumb", css: [
            {
                maxWidth: "100%",
                overflow: overflowX ? "scroll" : "hidden",
                WebkitOverflowScrolling: "touch",
                scrollbarWidth: "none",
                borderRadius: theme.radii.sm,
                msOverflowStyle: "none"
            },
            hideScrollbar
        ] }, other, { children: _jsx("ol", __assign({ className: "Breadcrumbs__list", css: {
                listStyle: "none",
                whiteSpace: "nowrap",
                display: "inline-flex",
                boxSizing: "border-box",
                overflow: "hidden",
                maxWidth: overflowX ? undefined : "100%",
                margin: 0,
                padding: theme.spaces.sm + " " + theme.spaces.md,
                borderRadius: theme.radii.md
            } }, { children: React.Children.map(children, function (child, i) {
                if (!React.isValidElement(child)) {
                    return child;
                }
                return React.cloneElement(child, {
                    size: size,
                    "aria-current": i === validChildrenCount(children) - 1 ? "page" : undefined
                });
            }) }), void 0) }), void 0));
};
Breadcrumbs.propTypes = {
    size: PropTypes.oneOf(["md", "lg"]),
    overflowX: PropTypes.number
};
function validChildrenCount(children) {
    return React.Children.toArray(children).filter(function (child) {
        return React.isValidElement(child);
    }).length;
}
/**
 *  Each item in a list of breadcrumbs.
 */
export var BreadcrumbItem = function (_a) {
    var children = _a.children, _b = _a.size, size = _b === void 0 ? "md" : _b, other = __rest(_a, ["children", "size"]);
    var current = other["aria-current"];
    return (_jsxs("li", __assign({ className: "BreadcrumbItem", css: {
            flex: "0 1 auto",
            overflow: "hidden",
            display: "flex",
            alignItems: "center"
        } }, other, { children: [_jsx(Text, __assign({ className: "BreadcrumbItem__text", wrap: false, component: "div", variant: size === "md" ? "body" : "h5", gutter: false, css: {
                    "& > a": {
                        textDecoration: "none"
                    }
                } }, { children: children }), void 0),
            !current && _jsx(BreadcrumbDivider, {}, void 0)] }), void 0));
};
BreadcrumbItem.propTypes = {
    children: PropTypes.node,
    size: PropTypes.oneOf(["md", "lg"])
};
var BreadcrumbDivider = function () {
    var theme = useTheme();
    return (_jsx(IconChevronRight, { className: "BreadcrumbDivider", color: theme.colors.text.muted, css: {
            flex: "0 0 auto",
            margin: "0 " + theme.spaces.sm
        } }, void 0));
};
BreadcrumbDivider.propTypes = {
    inverted: PropTypes.bool
};
var templateObject_1;
//# sourceMappingURL=Breadcrumbs.js.map