import { __assign, __extends } from "tslib";
import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import * as React from "react";
import { Alert } from "./Alert";
import PropTypes from "prop-types";
var ErrorBoundary = /** @class */ (function (_super) {
    __extends(ErrorBoundary, _super);
    function ErrorBoundary() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            error: null
        };
        return _this;
    }
    ErrorBoundary.prototype.componentDidCatch = function (error) {
        this.setState({ error: error });
    };
    ErrorBoundary.prototype.render = function () {
        if (this.state.error) {
            //render error message
            return (_jsx("div", __assign({ css: { padding: "1rem" } }, { children: _jsx(Alert, { type: "assertive", intent: "danger", title: this.props.title, subtitle: this.props.subtitle }, void 0) }), void 0));
        }
        else {
            //when there's not an error, render children untouched
            return this.props.children;
        }
    };
    ErrorBoundary.propTypes = {
        title: PropTypes.string,
        subtitle: PropTypes.string,
        children: PropTypes.node
    };
    ErrorBoundary.defaultProps = {
        title: "An unexpected error has occurred.",
        subtitle: "Please try reloading. If the problem persists, please contact us for help."
    };
    return ErrorBoundary;
}(React.Component));
export { ErrorBoundary };
//# sourceMappingURL=ErrorBoundary.js.map