import { __assign, __rest } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import * as React from "react";
import { Button, getHeight } from "./Button";
import VisuallyHidden from "@reach/visually-hidden";
import PropTypes from "prop-types";
import { IconWrapper } from "./IconWrapper";
import { IconX } from "./Icons";
import { useTheme } from "./Theme/Providers";
/**
 * A component which composes Button and Icon to provide
 * interactive icon elements.
 */
export var IconButton = React.forwardRef(function (_a, ref) {
    var _b;
    var label = _a.label, _c = _a.size, size = _c === void 0 ? "md" : _c, icon = _a.icon, onPress = _a.onPress, _d = _a.color, color = _d === void 0 ? "currentColor" : _d, other = __rest(_a, ["label", "size", "icon", "onPress", "color"]);
    var theme = useTheme();
    return (_jsxs(Button, __assign({ ref: ref, size: size, css: (_b = {
                padding: 0
            },
            _b[theme.mediaQueries.sm] = {
                padding: 0,
            },
            _b[theme.mediaQueries.lg] = {
                padding: 0,
            },
            _b.width = getHeight(size),
            _b), onPress: onPress }, other, { children: [_jsx(VisuallyHidden, { children: label }, void 0),
            _jsx(IconWrapper, __assign({ color: color, size: size }, { children: icon }), void 0)] }), void 0));
});
IconButton.displayName = "IconButton";
IconButton.propTypes = {
    icon: PropTypes.node.isRequired,
    color: PropTypes.string,
    label: PropTypes.string.isRequired,
    variant: PropTypes.oneOf(["outline", "default", "ghost"]),
    size: PropTypes.oneOf(["xs", "sm", "md", "lg", "xl"])
};
export var CloseButton = function (_a) {
    var _b = _a.label, label = _b === void 0 ? "Close" : _b, other = __rest(_a, ["label"]);
    return (_jsx(IconButton, __assign({ variant: "ghost", label: label, icon: _jsx(IconX, {}, void 0) }, other), void 0));
};
CloseButton.propTypes = {
    label: PropTypes.string,
    color: PropTypes.string,
    variant: PropTypes.oneOf(["outline", "default", "ghost"]),
    size: PropTypes.oneOf(["xs", "sm", "md", "lg", "xl"])
};
//# sourceMappingURL=IconButton.js.map