import { __assign } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import * as React from "react";
import { animated, useTransition } from "react-spring";
import { Portal } from "./Portal";
import { useHideBody } from "./Hooks/hide-body";
import PropTypes from "prop-types";
import { useTheme } from "./Theme/Providers";
export var Overlay = React.forwardRef(function (_a, ref) {
    var isOpen = _a.isOpen, onRequestClose = _a.onRequestClose, children = _a.children;
    var theme = useTheme();
    var transitions = useTransition(isOpen, {
        from: { opacity: 0 },
        enter: { opacity: 1 },
        leave: { opacity: 0 }
    });
    var bind = useHideBody(isOpen).bind;
    return (_jsx(Portal, { children: transitions(function (style, item) {
            return (item && _jsxs("div", __assign({ ref: ref }, bind, { onClick: function (e) {
                    e.stopPropagation();
                    onRequestClose();
                }, onKeyDown: function (e) {
                    if (e.key === "Escape") {
                        e.stopPropagation();
                        onRequestClose();
                    }
                }, css: {
                    bottom: 0,
                    left: 0,
                    overflow: "auto",
                    width: "100vw",
                    height: "100vh",
                    zIndex: theme.zIndices.overlay,
                    position: "fixed",
                    content: "''",
                    right: 0,
                    top: 0,
                    WebkitTapHighlightColor: "transparent"
                } }, { children: [_jsx(animated.div, { style: { opacity: style.opacity }, css: [
                            {
                                position: "absolute",
                                top: 0,
                                left: 0,
                                right: 0,
                                bottom: 0,
                                background: theme.colors.background.overlay
                            }
                        ] }, void 0), children] }), 1));
        }) }, void 0));
});
Overlay.displayName = "Overlay";
Overlay.propTypes = {
    isOpen: PropTypes.bool.isRequired,
    onRequestClose: PropTypes.func.isRequired,
    children: PropTypes.node
};
//# sourceMappingURL=Overlay.js.map