import { __assign, __makeTemplateObject } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
/** @jsxImportSource @emotion/react */
import { Global, css } from "@emotion/react";
import * as React from "react";
import toaster from "toasted-notes";
import { Alert } from "./Alert";
import { useTheme, ThemeProvider } from "./Theme/Providers";
var toastStyles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  .Toaster__message-wrapper {\n    padding: 8px;\n    text-align: left;\n  }\n"], ["\n  .Toaster__message-wrapper {\n    padding: 8px;\n    text-align: left;\n  }\n"])));
/**
 * We export toast as a hook because it allows us to consume
 * the current theme context that it's in and pass that
 * onto our render function
 */
export function useToast() {
    var theme = useTheme();
    function notify(_a) {
        var position = _a.position, duration = _a.duration, render = _a.render, title = _a.title, subtitle = _a.subtitle, intent = _a.intent;
        var options = {
            position: position,
            duration: duration
        };
        if (render) {
            return toaster.notify(function (_a) {
                var onClose = _a.onClose, id = _a.id;
                return (_jsxs(React.Fragment, { children: [_jsx(Global, { styles: toastStyles }, void 0),
                        _jsx(ThemeProvider, __assign({ theme: theme }, { children: render({ onClose: onClose, id: id }) }), void 0)] }, void 0));
            }, options);
        }
        toaster.notify(function (_a) {
            var onClose = _a.onClose, id = _a.id;
            return (_jsxs(React.Fragment, { children: [_jsx(Global, { styles: toastStyles }, void 0),
                    _jsx(ThemeProvider, __assign({ theme: theme }, { children: _jsx(Alert, { id: String(id), title: title, component: "div", elevation: "md", subtitle: subtitle, intent: intent, onRequestClose: onClose }, void 0) }), void 0)] }, void 0));
        }, options);
    }
    return notify;
}
var templateObject_1;
//# sourceMappingURL=Toast.js.map